package com.seeyon.v3x.edoc.manager;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.seeyon.ctp.organization.bo.V3xOrgDepartment;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.v3x.edoc.dao.EdocDocTemplateAclDao;
import com.seeyon.v3x.edoc.domain.EdocDocTemplateAcl;

public class EdocDocTemplateAclManagerImpl implements EdocDocTemplateAclManager{
	private static final Log log = LogFactory.getLog(EdocDocTemplateAclManagerImpl.class);

	private EdocDocTemplateAclDao edocDocTemplateAclDao;
	private OrgManager orgManager;

	public OrgManager getOrgManager() {
		return orgManager;
	}

	public void setOrgManager(OrgManager orgManager) {
		this.orgManager = orgManager;
	}

	public EdocDocTemplateAclDao getEdocDocTemplateAclDao() {
		return edocDocTemplateAclDao;
	}

	public void setEdocDocTemplateAclDao(EdocDocTemplateAclDao edocDocTemplateAclDao) {
		this.edocDocTemplateAclDao = edocDocTemplateAclDao;
	}

	public List<EdocDocTemplateAcl> getEdocDocTemplateAcl(String templateId){
		return edocDocTemplateAclDao.findEdocDocTemplateAcl(templateId);
	}

	public void saveEdocDocTemplateAcl(EdocDocTemplateAcl edocDocTemplateAcl){
		edocDocTemplateAclDao.saveEdocDocTemplateAcl(edocDocTemplateAcl);
	}
	public void saveEdocDocTemplateAcl(Long id,Long templateId,String[] departmentIds) throws Exception{

		for(String deptId:departmentIds){
			String[] bDeptId = deptId.split("\\|");
			if(bDeptId[2].equals("1")){
				long dId = Long.valueOf(bDeptId[1]);
				V3xOrgDepartment  dInfo = orgManager.getDepartmentById(dId);
				if(dInfo != null){
					//查出所有子部门并拼装部门串
					List<String> subListStr = edocDocTemplateAclDao.findOrgUnitSubDept(dInfo.getPath());
					if(subListStr !=null && subListStr.size() > 0){
						for(String subStr:subListStr){
							saveEdocDocTemplateAcl(templateId,subStr);
						}
					}
				}
			}
			saveEdocDocTemplateAcl(templateId,deptId);

		}
	}

	public void updateEdocDocTemplateAcl(Long id,Long templateId,String[] departmentIds) throws Exception{

		edocDocTemplateAclDao.deleteAclByTemplateId(templateId);
		for(String deptId:departmentIds){
			String[] bDeptId = deptId.split("\\|");
			if(bDeptId[2].equals("1")){
				long dId = Long.valueOf(bDeptId[1]);
				V3xOrgDepartment  dInfo = orgManager.getDepartmentById(dId);
				if(dInfo != null){
					//查出所有子部门并拼装部门串
					List<String> subListStr = edocDocTemplateAclDao.findOrgUnitSubDept(dInfo.getPath());
					if(subListStr !=null && subListStr.size() > 0){
						for(String subStr:subListStr){
							saveEdocDocTemplateAcl(templateId,subStr);
						}
					}
				}

			}
			saveEdocDocTemplateAcl(templateId,deptId);
		}
	}
	/**
	 * 保存套红模板授权信息
	 * @param templateId
	 * @param deptIdStr
	 * @throws Exception
	 */
	private void saveEdocDocTemplateAcl(Long templateId,String deptIdStr) throws Exception{
		EdocDocTemplateAcl edocDocTemplateAcl = new EdocDocTemplateAcl();
		edocDocTemplateAcl.setIdIfNew();
		edocDocTemplateAcl.setTemplateId(templateId);
		String[] bDeptId = deptIdStr.split("\\|");
		edocDocTemplateAcl.setDepType(bDeptId[0]);
		edocDocTemplateAcl.setDepId(Long.valueOf(bDeptId[1]));
		edocDocTemplateAclDao.saveEdocDocTemplateAcl(edocDocTemplateAcl);
	}
	public void deleteAclByTemplateId(Long templateId){
		edocDocTemplateAclDao.deleteAclByTemplateId(templateId);
	}
}
