package com.seeyon.v3x.edoc.manager;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.organization.po.OrgUnit;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.v3x.edoc.domain.EdocObjTeam;

public interface EdocObjTeamManager {
	
	public List<EdocObjTeam> findAll(Long accountId);
	
	/**
	 * 取得所有机构组，不分页
	 * 
	 * @param accountId
	 * @return
	 */
	public List<EdocObjTeam> findAllNotPager(Long accountId);
	public List<EdocObjTeam> findAllSimpleNotPager(Long accountId);
	public EdocObjTeam getById(Long teamId);
	public void update(EdocObjTeam edocObjTeam);
	public void save(EdocObjTeam edocObjTeam);
	public void delete(String ids);
	/**
	 * 判断交换单位数据是否有变化
	 * 
	 * @param orginalTimestamp
	 * @return
	 */
	public boolean isModifyExchangeAccounts(Date orginalTimestamp);
	
	public Date getLastModifyTimestamp();
	public String ajaxGetByName(String orgName,String accountIdStr);
	public Map<Long,String> getOrgTeamForDepartment(String ids,Long loginAccountId);
	/**
	 * @Title: 根据机构组id获取下级子数据
	 * @param @param teamId 机构组id
	 * @param @return    设定文件
	 * @return List<OrgUnit>   返回类型
	 * @throws
	 */
	public List<OrgUnit> getOrgTeamChildrenByTeamId(Long teamId) throws BusinessException;

	/**
	 * 根据条件分页查询机构组
	 * @param condition 查询条件
	 * @param flipInfo 分页参数
	 * @return
	 */
	public List<EdocObjTeam> findByConditionPager(Map<String,Object> condition, FlipInfo flipInfo);
	/**
	 * 根据查询条件分页获取机构组的子
	 * @param condition 条件
	 * @param flipInfo 分页参数
	 * @return
	 */
	public List<OrgUnit> getOrgTeamChildrenByConditionPager(Map<String,Object> condition, FlipInfo flipInfo);

}
